// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_UBlackboardKeyType.h"
#include <memory>

using std::shared_ptr;

namespace Sourcify
{	
	class ISCW_FBlackboardEntry
	{
	public:
		virtual ~ISCW_FBlackboardEntry() = default;
		
		virtual shared_ptr<ISCW_FBlackboardEntry> ToFBlackboardEntryPtr() = 0;
		virtual shared_ptr<const ISCW_FBlackboardEntry> ToFBlackboardEntryPtr() const = 0;

		virtual ISCW_UBlackboardKeyTypePtr GetKeyType() const = 0;
	};

	using ISCW_FBlackboardEntryConstPtr = shared_ptr<const ISCW_FBlackboardEntry>;
	using ISCW_FBlackboardEntryPtr = shared_ptr<ISCW_FBlackboardEntry>;
} // namespace Sourcify